use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use super::AdditionalProperties;
use crate::compare::ElispFact;
use crate::types::PlainText;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmPlainText {
    #[serde(flatten)]
    pub(crate) additional_properties: AdditionalProperties,
}

to_wasm!(
    WasmPlainText,
    PlainText<'s>,
    original,
    wasm_context,
    { WasmAstNode::PlainText(original) },
    { "plain-text".into() },
    {
        Ok((
            Vec::new(),
            WasmPlainText {
                additional_properties: AdditionalProperties::default(),
            },
        ))
    }
);
