use serde::Deserialize;
use serde::Serialize;

use super::ast_node::WasmAstNode;
use super::macros::to_wasm;
use super::to_wasm::ToWasm;
use super::AdditionalProperties;
use crate::compare::ElispFact;
use crate::types::Timestamp;
use crate::wasm::to_wasm::ToWasmStandardProperties;

#[derive(Debug, Serialize, Deserialize)]
pub struct WasmTimestamp {
    #[serde(flatten)]
    pub(crate) additional_properties: AdditionalProperties,
}

to_wasm!(
    WasmTimestamp,
    Timestamp<'s>,
    original,
    wasm_context,
    { WasmAstNode::Timestamp(original) },
    { "TODO".into() },
    {
        Ok((
            Vec::new(),
            WasmTimestamp {
                additional_properties: AdditionalProperties::default(),
            },
        ))
    }
);
